# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .list_metadata import ListMetadata
from .list_subtype import ListSubtype
from .list_type import ListType

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ListHeader(pydantic.BaseModel):
    list_id: str = pydantic.Field(alias="listId")
    list_type: ListType = pydantic.Field(alias="listType")
    subtype: ListSubtype
    metadata: typing.Optional[ListMetadata]
    created_timestamp: float = pydantic.Field(alias="createdTimestamp")
    size: typing.Optional[float]
    version: typing.Optional[float]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
